]> git.sesse.net Git - ffmpeg/blob - tests/fate.sh
lavc: export the timestamps when decoding in AVFrame.pts
[ffmpeg] / tests / fate.sh
1 #! /bin/sh
2
3 config=$1
4
5 die(){
6     echo "$@"
7     exit 1
8 }
9
10 test -r "$config"  || die "usage: fate.sh <config>"
11
12 workdir=$(cd $(dirname $config) && pwd)
13 make=make
14 tar='tar c'
15
16 . "$config"
17
18 test -n "$slot"    || die "slot not specified"
19 test -n "$repo"    || die "repo not specified"
20 test -d "$samples" || die "samples location not specified"
21
22 : ${branch:=master}
23
24 lock(){
25     lock=$1/fate.lock
26     (set -C; exec >$lock) 2>/dev/null || return
27     trap 'rm $lock' EXIT
28 }
29
30 checkout(){
31     case "$repo" in
32         file:*|/*) src="${repo#file:}"      ;;
33         git:*)     git clone --quiet --branch "$branch" "$repo" "$src" ;;
34     esac
35 }
36
37 update()(
38     cd ${src} || return
39     case "$repo" in
40         git:*) git fetch --quiet --force; git reset --quiet --hard "origin/$branch" ;;
41     esac
42 )
43
44 configure()(
45     cd ${build} || return
46     ${src}/configure                                                    \
47         --prefix="${inst}"                                              \
48         --samples="${samples}"                                          \
49         --enable-gpl                                                    \
50         ${arch:+--arch=$arch}                                           \
51         ${cpu:+--cpu="$cpu"}                                            \
52         ${toolchain:+--toolchain="$toolchain"}                          \
53         ${cross_prefix:+--cross-prefix="$cross_prefix"}                 \
54         ${as:+--as="$as"}                                               \
55         ${cc:+--cc="$cc"}                                               \
56         ${ld:+--ld="$ld"}                                               \
57         ${target_os:+--target-os="$target_os"}                          \
58         ${sysroot:+--sysroot="$sysroot"}                                \
59         ${target_exec:+--target-exec="$target_exec"}                    \
60         ${target_path:+--target-path="$target_path"}                    \
61         ${target_samples:+--target-samples="$target_samples"}           \
62         ${extra_cflags:+--extra-cflags="$extra_cflags"}                 \
63         ${extra_ldflags:+--extra-ldflags="$extra_ldflags"}              \
64         ${extra_libs:+--extra-libs="$extra_libs"}                       \
65         ${extra_conf}
66 )
67
68 compile()(
69     cd ${build} || return
70     ${make} ${makeopts} && ${make} install
71 )
72
73 fate()(
74     test "$build_only" = "yes" && return
75     cd ${build} || return
76     ${make} ${makeopts} -k fate
77 )
78
79 clean(){
80     rm -rf ${build} ${inst}
81 }
82
83 report(){
84     date=$(date -u +%Y%m%d%H%M%S)
85     echo "fate:1:${date}:${slot}:${version}:$1:$2:${branch}:${comment}" >report
86     cat ${build}/config.fate ${build}/tests/data/fate/*.rep >>report 2>/dev/null
87     test -n "$fate_recv" && $tar report *.log | gzip | $fate_recv
88 }
89
90 fail(){
91     report "$@"
92     clean
93     exit
94 }
95
96 mkdir -p ${workdir} || die "Error creating ${workdir}"
97 lock ${workdir}     || die "${workdir} locked"
98 cd ${workdir}       || die "cd ${workdir} failed"
99
100 src=${workdir}/src
101 : ${build:=${workdir}/build}
102 : ${inst:=${workdir}/install}
103
104 test -d "$src" && update || checkout || die "Error fetching source"
105
106 cd ${workdir}
107
108 version=$(${src}/version.sh ${src})
109 test "$version" = "$(cat version-$slot 2>/dev/null)" && exit 0
110 echo ${version} >version-$slot
111
112 rm -rf "${build}" *.log
113 mkdir -p ${build}
114
115 configure >configure.log 2>&1 || fail $? "error configuring"
116 compile   >compile.log   2>&1 || fail $? "error compiling"
117 fate      >test.log      2>&1 || fail $? "error testing"
118 report 0 success
119 clean